name: guacamole

# networks
networks:
  guacamole_network:
    driver: bridge

# services
services:
  # guacd
  guacd:
    container_name: guacamole_server
    image: guacamole-server-1.6.0
    networks:
      guacamole_network:
    restart: always
    healthcheck:
      test: [ "CMD-SHELL", "nc -z 127.0.0.1 4822 || exit 1" ]
      interval: 60s
      timeout: 10s
      retries: 1
      start_period: 30s
    volumes:
      - ./drive:/files/drive:rw # Required for storing file transfers
      - ./record:/files/record:rw # Required for recording sessions

  # guacamole
  guacamole:
    container_name: guacamole_client
    image: guacamole-client-1.6.0
    depends_on:
      - guacd
      - postgres
    environment:
      WEBAPP_CONTEXT: ROOT # Makes it available at base context 0.0.0.0/ instead of 0.0.0.0/guacamole
      GUACD_HOSTNAME: guacd
      POSTGRESQL_HOSTNAME: postgres
      POSTGRESQL_DATABASE: guacamole_db
      POSTGRESQL_USERNAME: guacamole_user
      POSTGRESQL_PASSWORD:  # Insert your postgresql password here
      TOTP_ENABLED: true
      NOTIFIER_ENABLED: true
      NOTIFIER_NTFY_DOMAIN:  # Insert the NTFY domain # Required if notifier enabled
      NOTIFIER_NTFY_TOPIC:  # Insert the NTFY topic # Required if notifier enabled
      NOTIFIER_GUACAMOLE_URL:  # Insert the guacamole URL # Required if notifier enabled
      NOTIFIER_ON_STARTUP: true
      NOTIFIER_ON_SHUTDOWN: true
      NOTIFIER_ON_SUCCESS: true
      NOTIFIER_ON_RESUCCESS: false
      NOTIFIER_ON_FAILURE: true
      RECORDING_SEARCH_PATH: /files/record # Required for playing back recordings in browser
      HTTPS_ENABLED: true
      HTTPS_HTTPS_PORT: 8443
      HTTPS_KEYSTORE_FILE: /files/config/certs/self.jks # Required if SSL enabled (generated by running ./prepare.sh)
      HTTPS_KEYSTORE_PASS:  # Insert your keystore password here # Required if SSL enabled (should be same as in ./prepare.sh)
      HTTPS_KEY_ALIAS: tomcat # Required if SSL enabled (should be same as in ./prepare.sh)
      #LOG_LEVEL: debug
    networks:
      guacamole_network:
    ports:
      - 0.0.0.0:10300:8080 # http
      - 0.0.0.0:10301:8443 # https
    restart: always
    healthcheck:
      test: [ "CMD-SHELL", "curl -s 127.0.0.1:8080 | grep -q guac-login" ]
      interval: 60s
      timeout: 10s
      retries: 1
      start_period: 30s
    volumes:
      - ./record:/files/record:rw # Required for playing back recordings in browser
      - ./config/certs/self.jks:/files/config/certs/self.jks # Required for SSL certificates

  # postgres
  postgres:
    container_name: guacamole_postgres
    image: postgres:15.2-alpine
    environment:
      PGDATA: /var/lib/postgresql/data/guacamole
      POSTGRES_DB: guacamole_db
      POSTGRES_USER: guacamole_user
      POSTGRES_PASSWORD:  # Insert your postgresql password here
    networks:
      guacamole_network:
    restart: always
    healthcheck:
      test: [ "CMD-SHELL", "pg_isready -d $${POSTGRES_DB} -U $${POSTGRES_USER}" ]
      interval: 60s
      timeout: 10s
      retries: 1
      start_period: 30s
    volumes:
      - ./init:/docker-entrypoint-initdb.d:z # Required for initial database sql setup
      - ./data:/var/lib/postgresql/data:Z # Required for persistent database storage

# Inspired by https://github.com/boschkundendienst/guacamole-docker-compose
